Index: branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Request/RequestPrint/FrmRequestPrintSelPrtOut.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Request/RequestPrint/FrmRequestPrintSelPrtOut.cs	(nonexistent)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Request/RequestPrint/FrmRequestPrintSelPrtOut.cs	(revision 369)
@@ -0,0 +1,1364 @@
+﻿using System;
+using System.Collections;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Data;
+using System.Drawing;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using System.Windows.Forms;
+
+using ProcessManagement.Common;
+using ProcessManagement.DataModel;
+using ProcessManagement.DB;
+using ProcessManagement.DB.IOAccess;
+using ProcessManagement.Forms.SubForms;
+using ProcessManagement.Forms.ControlsAction;
+
+
+namespace ProcessManagement.Forms.DataEntry
+{
+    public partial class FrmRequestPrintSel
+    {
+        #region 定数
+
+        /// <summary>
+        /// Excelテンプレートファイル名
+        /// </summary>
+        //private static string s_ExcelRequestSheetFileName = @"\RequestSheet.xlsx";
+        private static string s_ExcelRequestSheetFileName = CommonDefine.s_ExcelOriginalFileName;
+
+        /// <summary>
+        /// デスクトップフォルダ名
+        /// </summary>
+        private static string s_ExecCurrentDirName = System.Environment.GetFolderPath(Environment.SpecialFolder.DesktopDirectory);
+
+        /// <summary>
+        /// シート名称カウント
+        /// </summary>
+        enum enumSheetName
+        {
+            Cover = 0,
+            List,
+            Detail,
+        }
+
+        /// <summary>
+        /// Excel シート名称
+        /// </summary>
+        private static readonly Dictionary<enumSheetName, string> s_DicSheetName = new Dictionary<enumSheetName, string>()
+        {
+            { enumSheetName.Cover, "請求書（表紙）" },
+            { enumSheetName.List, "請求書（一覧）" },
+            { enumSheetName.Detail, "請求書（内訳）" },
+        };
+
+        /// <summary>
+        /// 図形置き場シート
+        /// </summary>
+        private const string s_shapeSheetName = "図形シート";
+        /// <summary>
+        /// 図形名称
+        /// </summary>
+        private const string s_shapeName = "EstimateSeal1";                                    // 積算見積表紙判子
+        /// <summary>
+        /// 図形サイズ【縦・横】（図形名称順）
+        /// </summary>
+        private static float[,] s_ShapeSize = new float[1, 2] { { 25.51f, 25.51f } };         // 積算見積表紙判子
+        /// <summary>
+        /// 積算見積表紙判子フォントサイズ
+        /// </summary>
+        private static float[] s_EstimateSeal1FontSize = { 16f, 8f, 8f, 8f, 6f };
+        /// <summary>
+        /// 表紙判子位置(Key:X Value:Y)
+        /// </summary>
+        private static float[,] s_CoverSealPoint = new float[4, 2] {{592.50f, 555.25f},    // 社長
+                                                                    {657.25f, 555.25f},    // 所属長
+                                                                    {721.00f, 555.25f},    // 営業
+                                                                    {784.00f, 555.25f} };  // 担当
+
+        #endregion
+
+        #region 変数
+
+        #region スレッド使用定義
+        //コントロールの値を変更するためのデリゲート
+        private delegate void SetProgressValueDelegate(int num);
+        //バックグラウンド処理が終わった時にコントロールの値を変更するためのデリゲート
+        private delegate void ThreadCompletedDelegate();
+        //処理がキャンセルされた時にコントロールの値を変更するためのデリゲート
+        private delegate void ThreadCanceledDelegate();
+
+        //別処理をするためのスレッド
+        private System.Threading.Thread workerThread;
+
+        //デリゲートの作成
+        SetProgressValueDelegate m_progressDlg = null;
+        ThreadCompletedDelegate m_completeDlg = null;
+        ThreadCanceledDelegate m_canceledDlg = null;
+        #endregion
+
+        /// <summary>
+        /// Excel印刷クラスオブジェクト
+        /// </summary>
+        private UsedExcel m_UsedExcel = null;
+
+        /// <summary>
+        /// 保存時Excelパス
+        /// </summary>
+        private string m_SelectSaveExcel = "";
+
+        /// <summary>
+        /// 請求書データ
+        /// </summary>
+        private InvoiceData m_InvData = new InvoiceData();
+
+        /// <summary>
+        /// 請求データ
+        /// </summary>
+        private Dictionary<int, List<RequestData>> m_dicReqData = new Dictionary<int, List<RequestData>>();
+
+        /// <summary>
+        /// 工事基本情報データ
+        /// </summary>
+        private Dictionary<int, ConstructionBaseInfo> m_dicConstructionBaseInfo = new Dictionary<int, ConstructionBaseInfo>();
+
+        /// <summary>
+        /// 日付印刷
+        /// </summary>
+        private bool m_bDatePrintFlg = true;
+
+        /// <summary>
+        /// 印刷日付
+        /// </summary>
+        private DateTime m_DatePrintOut = DateTime.Now;
+
+        /// <summary>
+        /// 印刷処理プロセス数カウント
+        /// </summary>
+        private int m_ProcessCount = 0;
+
+        /// <summary>
+        /// プログレスバー使用カウント
+        /// </summary>
+        private int m_ProgressCount = 0;
+
+        /// <summary>
+        /// キャンセルボタンがクリックされたかを示すフラグ
+        /// </summary>
+        private volatile bool m_Canceled = false;
+        /// <summary>
+        /// 実行ダイアログ選択値
+        /// </summary>
+        private DialogResult m_PrintresRet = DialogResult.Cancel;
+
+        /// <summary>
+        /// 終了コード
+        /// </summary>
+        private CommonDefine.RetunAnswer m_rtAns = CommonDefine.RetunAnswer.Answer0;
+
+        #endregion
+
+        #region プロパティ
+
+        #endregion
+
+        #region 工事基本情報取得
+        /// <summary>
+        /// 工事基本情報取得
+        /// </summary>
+        /// <param name="constructionCode"></param>
+        /// <param name="data"></param>
+        /// <returns></returns>
+        private bool GetConstructionBaseInfo(int constructionCode, ref ConstructionBaseInfo data)
+        {
+            var cbDB = new IOConstructionBaseInfo();
+            try
+            {
+                // 工事基本情報取得クラス領域
+                var wrk = new ConstructionBaseInfo();
+
+                // 工事基本情報取得SQL
+                string strSQL = cbDB.CreatePrimarykeyString(constructionCode);
+
+                // 工事基本情報取得
+                if (!cbDB.SelectAction(strSQL, ref wrk)) return false;
+
+                // 工事基本情報取得クラス領域
+                data = wrk;
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                cbDB.close(); cbDB = null;
+            }
+            return true;
+        }
+        #endregion
+
+        #region 結合親工事番号の取得
+        /// <summary>
+        /// 結合親工事番号の取得
+        /// </summary>
+        /// <param name="nConstructionCode"></param>
+        /// <returns></returns>
+        private int GetJoinParentConstructionCode(int nConstructionCode)
+        {
+            int nParentCode = -1;
+            IOConstructionLink ioLink = new IOConstructionLink();
+
+            try
+            {
+                string sql = string.Format(" WHERE FluctuationCode = {0} AND LinkType = 1 ", nConstructionCode);
+                List<ConstructionLink> lstWork = new List<ConstructionLink>();
+
+                if (ioLink.SelectAction(sql, ref lstWork) == false)
+                {
+                    return nParentCode;
+                }
+
+                foreach (ConstructionLink Link in lstWork)
+                {
+                    nParentCode = Link.ConstructionCode;
+                    break;
+                }
+                return nParentCode;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return -1;
+            }
+            finally
+            {
+                ioLink.close();
+                ioLink = null;
+            }
+
+        }
+        #endregion
+
+        #region 工事基本情報明細
+        /// <summary>
+        /// 工事基本情報明細を工事基本情報明細テーブルから工事番号をキーに取得する関数
+        /// </summary>
+        /// <param name="datas"></param>
+        /// <returns></returns>
+        private bool GetConstructionBaseInfoDetail(List<int> lstConstCode, ref Dictionary<int, Dictionary<int, string>> datas)
+        {
+            var sbDB = new IOConstructionBaseInfoDetail();
+            try
+            {
+                // 工事基本情報明細取得クラス領域
+                var wrk = new List<ConstructionBaseInfoDetail>();
+
+                // 工事基本情報明細取得SQL
+                StringBuilder strSQL = new StringBuilder();
+                strSQL.Append(" Where ConstructionCode in ( ");
+                foreach (int constCode in lstConstCode)
+                {
+                    strSQL.AppendFormat((lstConstCode.IndexOf(constCode) == 0) ? " {0}" : ", {0}", constCode);
+                }
+                strSQL.Append(" )");
+
+                // 工事基本情報明細取得
+                if (!sbDB.SelectAction(strSQL.ToString(), ref wrk)) return false;
+
+                datas.Clear();
+
+                foreach (var record in wrk)
+                {
+                    if (!datas.ContainsKey(record.ConstructionCode))
+                        datas[record.ConstructionCode] = new Dictionary<int, string>();
+                    datas[record.ConstructionCode][record.DetailNo] = record.DetailString;
+                }
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                sbDB.close();
+                sbDB = null;
+            }
+
+            return true;
+        }
+        #endregion
+
+        #region 工事増減情報取得
+        /// <summary>
+        /// 工事増減情報取得
+        /// </summary>
+        /// <param name="constructionCode"></param>
+        /// <param name="datas"></param>
+        /// <returns></returns>
+        private bool GetConstructionLink(int constructionCode, ref List<int> datas)
+        {
+            var sbDB = new IOConstructionLink();
+            try
+            {
+                // 工事増減情報取得クラス領域
+                var wrk = new List<ConstructionLink>();
+
+                // 工事増減情報取得SQL
+                string strSQL = sbDB.CreatePrimarykeyString(constructionCode);
+
+                // ソート条件追加
+                strSQL += " ORDER BY FLUCTUATIONCODE";
+
+                // 工事増減情報取得
+                if (!sbDB.SelectAction(strSQL, ref wrk)) return false;
+
+                foreach (var record in wrk)
+                {
+                    datas.Add(record.FluctuationCode);
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                sbDB.close();
+                sbDB = null;
+            }
+
+            return true;
+        }
+        #endregion
+
+        #region 工事詳細台帳データ取得
+        /// <summary>
+        /// 工事詳細台帳データ取得
+        /// </summary>
+        /// <param name="constructionCode"></param>
+        /// <param name="data"></param>
+        /// <returns></returns>
+        private bool GetConstructionLedger(int constructionCode, ref ConstructionLedger data)
+        {
+            var sbDB = new IOConstructionLedger();
+            try
+            {
+                // 工事詳細台帳データ取得クラス領域
+                var wrk = new ConstructionLedger();
+
+                // 工事詳細台帳データ取得SQL
+                string strSQL = sbDB.CreatePrimarykeyString(constructionCode);
+
+                // 工事詳細台帳データ取得
+                if (!sbDB.SelectAction(strSQL, ref wrk)) return false;
+
+                data = wrk;
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                sbDB.close();
+                sbDB = null;
+            }
+
+            return true;
+        }
+        #endregion
+
+        #region プログレスバーの値を変更する
+        /// <summary>
+        /// プログレスバーの値を変更する
+        /// </summary>
+        /// <param name="num"></param>
+        private void SetProgressValue(int num)
+        {
+            // ProgressBarの値を変更する
+            PrintProgress.Value = num;
+            PrintProgress.Update();
+        }
+        #endregion
+
+        #region 処理が完了した時にコントロールの値を変更する
+        /// <summary>
+        /// 処理が完了した時にコントロールの値を変更する
+        /// </summary>
+        private void ThreadCompleted()
+        {
+            try
+            {
+                // コントロールの変更
+                PrintProgress.Visible = false;
+                panel2.Update();
+
+                // ボタンの変更
+                PrintButtonVisbleControl(false);
+
+                // 印刷
+                if (m_rtAns == CommonDefine.RetunAnswer.Answer0)
+                {
+                    if (m_PrintresRet == DialogResult.No)
+                    {
+                        MessageBox.Show("保存が終了しました。", "終　了", MessageBoxButtons.OK, MessageBoxIcon.Information);
+                    }
+                    return;
+                }
+
+                string strMessage = "";
+                switch ((int)m_rtAns)
+                {
+                    case (int)CommonDefine.RetunAnswer.Answer1:
+                        strMessage = "システムエラー";
+                        break;
+                    case (int)CommonDefine.RetunAnswer.Answer2:
+                        strMessage = "工事基本情報取得エラー";
+                        break;
+                }
+                MessageBox.Show(strMessage, "印刷エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                m_rtAns = CommonDefine.RetunAnswer.Answer1;
+            }
+        }
+        #endregion
+
+        #region 印刷時ボタン制御
+        /// <summary>
+        /// 印刷時ボタン制御
+        /// </summary>
+        /// <param name="bprint"></param>
+        private void PrintButtonVisbleControl(bool bprint)
+        {
+            if (bprint)
+            {
+                btnGenerate.Visible = false;
+                btnDel.Visible = false;
+                btnEnd.Visible = false;
+                btnCancel.Visible = true;
+                PrintProgress.Visible = true;
+            }
+            else
+            {
+                btnGenerate.Visible = true;
+                btnDel.Visible = true;
+                btnEnd.Visible = true;
+                btnCancel.Visible = false;
+                PrintProgress.Visible = false;
+            }
+
+        }
+        #endregion
+
+        #region 処理がキャンセルされた時にコントロールの値を変更する
+        /// <summary>
+        /// 処理がキャンセルされた時にコントロールの値を変更する
+        /// </summary>
+        private void ThreadCanceled()
+        {
+            // コントロールの変更
+            PrintProgress.Visible = false;
+            panel2.Update();
+
+            // ボタンの変更
+            PrintButtonVisbleControl(false);
+        }
+        #endregion
+
+        #region 印刷メイン
+        /// <summary>
+        /// 印刷メイン
+        /// </summary>
+        /// <param name="bPrint">true:印刷のみ,false:保存のみ</param>
+        public void PrintMain(object args)
+        {
+            try
+            {
+                object[] argsTmp = (object[])args;
+                bool bPrint = true;
+                for (int i = 0; i < argsTmp.Length; i++)
+                {
+                    bPrint = (bool)argsTmp[i];
+                }
+
+                //デリゲートの作成
+                m_progressDlg = new SetProgressValueDelegate(SetProgressValue);
+                m_completeDlg = new ThreadCompletedDelegate(ThreadCompleted);
+                m_canceledDlg = new ThreadCanceledDelegate(ThreadCanceled);
+
+                // 印刷クラス
+                m_UsedExcel = new UsedExcel();
+                m_ProgressCount = 0;
+
+                // コントロールの表示を変更する
+                this.Invoke(m_progressDlg, new object[] { ++m_ProgressCount });
+                // エクセルブックオープン
+                if (!m_UsedExcel.ExcelBookOpen(System.Environment.CurrentDirectory + s_ExcelRequestSheetFileName))
+                {
+                    m_rtAns = CommonDefine.RetunAnswer.Answer5;
+                    return;
+                }
+
+                // 中断処理
+                if (m_Canceled) return;
+
+                // コントロールの表示を変更する
+                this.Invoke(m_progressDlg, new object[] { ++m_ProgressCount });
+
+                // 表紙印刷
+                CommonDefine.RetunAnswer rtAns = PrintCover();
+                if (rtAns != CommonDefine.RetunAnswer.Answer0)
+                {
+                    m_rtAns = rtAns;
+                    return;
+                }
+
+                // 中断処理
+                if (m_Canceled) return;
+
+                // コントロールの表示を変更する
+                this.Invoke(m_progressDlg, new object[] { ++m_ProgressCount });
+
+                // 一覧印刷
+                rtAns = PrintList();
+                if (rtAns != CommonDefine.RetunAnswer.Answer0)
+                {
+                    m_rtAns = rtAns;
+                    return;
+                }
+
+                // 中断処理
+                if (m_Canceled) return;
+
+                // コントロールの表示を変更する
+                this.Invoke(m_progressDlg, new object[] { ++m_ProgressCount });
+
+                int no = 1;
+                foreach (RequestHead ReqHead in m_lstReqHead)
+                {
+                    List<RequestData> lstReqData = null;
+                    if (!m_dicReqData.TryGetValue(ReqHead.RequestNo, out lstReqData)) continue;
+                    //{
+                    //    m_rtAns = rtAns;
+                    //    return;
+                    //}
+
+                    foreach (RequestData ReqData in lstReqData)
+                    {
+                        if (!m_dicConstructionBaseInfo.TryGetValue(ReqData.MainConstructionCode, out ConstructionBaseInfo Info)) continue;
+                        //{
+                        //    m_rtAns = CommonDefine.RetunAnswer.Answer2;
+                        //    return;
+                        //}
+
+                        long lRequestAmount = ReqData.RequestAmount0;
+                        lRequestAmount += ReqData.RequestAmount1;
+                        lRequestAmount += ReqData.RequestAmount2;
+                        lRequestAmount += ReqData.RequestAmount3;
+                        lRequestAmount += ReqData.RequestAmount4;
+                        lRequestAmount += ReqData.RequestAmount5;
+                        lRequestAmount += ReqData.RequestAmount6;
+                        lRequestAmount += ReqData.UnpaidAmount;
+
+                        if (lRequestAmount == 0)
+                        {
+                            continue;
+                        }
+
+                        rtAns = PrintDetail(no, ReqHead, ReqData, Info);
+                        if (rtAns != CommonDefine.RetunAnswer.Answer0)
+                        {
+                            m_rtAns = rtAns;
+                            return;
+                        }
+                        // 中断処理
+                        if (m_Canceled) return;
+
+                        // コントロールの表示を変更する
+                        this.Invoke(m_progressDlg, new object[] { ++m_ProgressCount });
+                    }
+                }
+
+                if (bPrint)
+                {
+                    // 印刷処理
+                    m_UsedExcel.ExcelSheetPrint();
+                }
+                else
+                {
+                    // 保存処理
+                    SaveExcelFile();
+                }
+
+                // コントロールの表示を変更する
+                this.Invoke(m_progressDlg, new object[] { ++m_ProgressCount });
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                // 完了したときにコントロールの値を変更する
+                this.Invoke(m_completeDlg);
+
+                //デリゲートの廃棄
+                m_progressDlg = null;
+                m_completeDlg = null;
+                m_canceledDlg = null;
+
+                // Excel開放
+                if (m_UsedExcel != null)
+                {
+                    m_UsedExcel.ExcelBookClose();
+                }
+                m_UsedExcel = null;
+
+                // ガーベージコレクト
+                GC.Collect();
+            }
+        }
+        #endregion
+
+        #region Excelファイル保存処理
+        /// <summary>
+        /// Excelファイル保存処理
+        /// </summary>
+        private void SaveExcelFile()
+        {
+            try
+            {
+                string filePath = @m_SelectSaveExcel;
+
+                // ファイルパスの存在をチェック
+                if (CommonMotions.ChkDirPath(filePath, true))
+                {
+                    // ファイル名を作成
+                    string wrkFile = m_InvData.RequestName + "様 請求書";
+
+                    // ファイル名に使用できない文字を取り除く
+                    foreach (var badCh in m_UsedExcel.ExcelBadCharcter)
+                    {
+                        wrkFile = wrkFile.Replace(badCh, "");
+                    }
+
+                    // ファイル名作成
+                    filePath += @"\" + @wrkFile;
+
+                    // ファイル保存
+                    m_UsedExcel.SaveSwitch = true;
+                    m_UsedExcel.ExcelSaveBook(filePath);
+
+                }
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+
+        }
+        #endregion
+
+        #region エリアスを付けた担当者マスタのフィールド文を作成する
+        /// <summary>
+        /// エリアスを付けた担当者マスタのフィールド文を作成する
+        /// </summary>
+        /// <param name="Alias"></param>
+        /// <param name="strSQL"></param>
+        private string CreatePersonSQL(string Alias)
+        {
+            try
+            {
+                StringBuilder strcmd = new StringBuilder();
+
+                bool bColFirst = true;
+                string strWork = string.Empty;
+                foreach (var gender in Enum.GetValues(typeof(IOMPersonInCharge.ColumnCnt)))
+                {
+                    strWork = gender.ToString();
+                    if (!bColFirst) strcmd.Append(", ");
+                    if (strWork.Equals("StartDate") || strWork.Equals("EndDate"))
+                    {
+                        strcmd.AppendFormat(" DATE_FORMAT({0}{1}, '%Y/%m/%d')", Alias, strWork);
+                    }
+                    else if (strWork.Equals("EntryDate") || strWork.Equals("UpdateDate"))
+                    {
+                        strcmd.AppendFormat(" DATE_FORMAT({0}{1}, '%Y/%m/%d %H:%i:%s')", Alias, strWork);
+                    }
+                    else
+                    {
+                        strcmd.AppendFormat(" {0}{1}", Alias, strWork);
+                    }
+                    bColFirst = false;
+                }
+
+                return strcmd.ToString();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return string.Empty;
+            }
+        }
+        #endregion
+
+        #region 表紙印鑑表示
+        /// <summary>
+        ///  表紙印鑑表示
+        /// </summary>
+        private void PrintCoverSeal(int PersonCode)
+        {
+            IOMPersonInCharge picDB = new IOMPersonInCharge();
+            IOProcessApproval paDB = new IOProcessApproval();
+            try
+            {
+                ArrayList arlist = new ArrayList();
+
+                // 承認データ読込
+                StringBuilder strSQLSeal = new StringBuilder();
+                strSQLSeal.Append("SELECT");
+                strSQLSeal.Append(CreatePersonSQL("B."));
+                strSQLSeal.Append(", C.SECRANK FROM PROCESSAPPROVAL A, PERSONINCHARGEMASTER B, SECURITYMASTER C");
+                strSQLSeal.Append(paDB.CreatePrimarykeyString(m_lstReqHead[0].ReqConstructionCode, (int)ClsExcute.ApprovalListNo.OrderRequestApproval, m_lstReqHead[0].OrderNo));
+                strSQLSeal.Append(" AND A.PERSONCODE = B.PERSONCODE");
+                strSQLSeal.Append(" AND C.SECCODE = B.SECCODE");
+                strSQLSeal.Append(" Order By C.SecRank ASC");
+                if (!paDB.ExecuteReader(strSQLSeal.ToString(), ref arlist)) return;
+
+                // 印刷テーブル作成
+                int[] PorsonCode = new int[4] { 0, 0, 0, 0 };
+                List<string> NameTable = new List<string>();
+                for (int i = 0; i < PorsonCode.Length; i++) NameTable.Add("");
+                string[] OrderOfPrecedenceTable = new string[4];
+
+                int PersonDataCnt = Enum.GetNames(typeof(IOMPersonInCharge.ColumnCnt)).Length;
+                // 承認データより担当者その他を取得する
+                for (int i = 0; i < arlist.Count; i++)
+                {
+                    // エクセルの枠より多い場合は処理を抜ける
+                    if (i > 3) break;
+
+                    object[] readObj = (object[])arlist[i];
+                    PersonInChargeMaster PersonRec = new PersonInChargeMaster();
+                    picDB.Reader2Struct(readObj, ref PersonRec);
+
+                    // セキュリティデータチェック
+                    int SecRank = CommonMotions.cnvInt(readObj[PersonDataCnt]);
+                    int SRank = (int)CommonDefine.SecurityRankPos.SpecialAuthority;     // 特別権限
+                    int FRank = (int)CommonDefine.SecurityRankPos.FreeAuthority;        // 統括者権限
+                    int LRank = (int)CommonDefine.SecurityRankPos.LimitedAuthority;     // 所属長権限
+
+                    // 担当者以外は役職がある
+                    if (SecRank == CommonDefine.SecurityRankList[SRank].Key
+                        || SecRank == CommonDefine.SecurityRankList[FRank].Key
+                        || SecRank == CommonDefine.SecurityRankList[LRank].Key)
+                    {
+                        // コードと名前と役職を取得する
+                        PorsonCode[i] = PersonRec.PersonCode;
+                        NameTable[i] = PersonRec.SealPrintName;
+                        // 7文字以上は文字が見えないので省略
+                        if (PersonRec.DisplayString.Length > 7)
+                        {
+                            OrderOfPrecedenceTable[i] = PersonRec.DisplayString.Substring(0, 7);
+                        }
+                        else if (PersonRec.DisplayString.Length < 1)
+                        {
+                            OrderOfPrecedenceTable[i] = "担　当";
+                        }
+                        else
+                        {
+                            OrderOfPrecedenceTable[i] = PersonRec.DisplayString;
+                        }
+                    }
+                    else
+                    {   // 担当者
+                        // コードと名前を取得する
+                        PorsonCode[3] = PersonRec.PersonCode;
+                        NameTable[3] = PersonRec.SealPrintName;
+                        OrderOfPrecedenceTable[3] = "担　当";
+                    }
+                }
+                // テーブル内に同じコードが無いか後から調べる
+                for (int i = 0; i < PorsonCode.Length - 1; i++)
+                {
+                    if (PorsonCode[i] == 0) continue;
+                    for (int ii = 0; ii < PorsonCode.Length; ii++)
+                    {
+                        if (i == ii) continue;
+                        if (PorsonCode[i] != PorsonCode[ii]) continue;
+
+                        PorsonCode[ii] = 0;
+                        NameTable[ii] = string.Empty;
+                        OrderOfPrecedenceTable[ii] = string.Empty;
+                        break;
+                    }
+                }
+
+                // 印鑑を描画する
+                OfficeShapeDefine shapedef = new OfficeShapeDefine();
+                shapedef.ShapeSheetName = s_shapeSheetName;     // 図形シート名称
+                shapedef.ShapeName = s_shapeName;               // 図形名称
+                shapedef.ShapeWidth = s_ShapeSize[0, 0];        // 図形描画サイズ Width
+                shapedef.ShapeHeight = s_ShapeSize[0, 1];       // 図形描画サイズ Height
+
+                for (int i = 0; i < 4; i++)
+                {
+                    // 
+                    if (PorsonCode[i] != 0)
+                    {
+                        shapedef.ShapeDrowPointX = s_CoverSealPoint[i, 0];          // 図形描画位置 X
+                        shapedef.ShapeDrowPointY = s_CoverSealPoint[i, 1];          // 図形描画位置 Y
+                        shapedef.DrowText = NameTable[i];                           // 描画文字列
+                        int ifontSize = NameTable[i].Length - 1;
+                        if (ifontSize > 4) ifontSize = 4;
+                        shapedef.FontSize = s_EstimateSeal1FontSize[ifontSize];     // フォントサイズ
+                        // 図形描画
+                        m_UsedExcel.ExcelCopyShape(shapedef);
+                    }
+                    // 役職を印字する(M～)
+                    int orgNumber = 11 + i;
+                    string strAlpha = CommonMotions.cnvNumberToAlphaCharacter(orgNumber);
+                    m_UsedExcel.ExcelCellSet(string.Format("{0}25", strAlpha), OrderOfPrecedenceTable[i]);
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                paDB.close(); paDB = null;
+                picDB.close(); picDB = null;
+            }
+        }
+        #endregion
+
+        #region 請求書(表紙)作成
+        /// <summary>
+        /// 請求書(表紙)作成
+        /// </summary>
+        /// <returns></returns>
+        private CommonDefine.RetunAnswer PrintCover()
+        {
+            try
+            {
+                // 請求書表紙シートの取得
+                m_UsedExcel.ExcelSheetGet(s_DicSheetName[enumSheetName.Cover]);
+
+                // 請求書No(4行目 N列)
+                string strInvNo = (m_InvData.InvoiceNo / 1000).ToString();
+                strInvNo += "-";
+                strInvNo += (m_InvData.InvoiceNo % 1000).ToString("00");
+
+                ExcelPrintData InvNoData = new ExcelPrintData();
+                InvNoData.AddPrintData("N", 3, strInvNo).ExcelCellSet(m_UsedExcel);
+
+
+                // ③ 請求日(5行目 M列)
+                if (m_bDatePrintFlg == true)
+                {
+                    ExcelPrintData reqDate = new ExcelPrintData();
+                    reqDate.AddPrintData("M", 4, m_DatePrintOut.ToString("yyyy/MM/dd")).ExcelCellSet(m_UsedExcel);
+                }
+                else
+                {
+                    ExcelPrintData reqDate = new ExcelPrintData();
+                    reqDate.AddPrintData("M", 4, "　　年　　月　　日").ExcelCellSet(m_UsedExcel);
+                }
+
+                // ④ 請求先名称(9行目 C列)
+                ExcelPrintData nameData = new ExcelPrintData();
+                string str = m_InvData.RequestName + "　様";
+                nameData.AddPrintData("C", 8, str).ExcelCellSet(m_UsedExcel);
+
+                // ⑤ 請求金額(13行目 C列)
+                ExcelPrintData priceData = new ExcelPrintData();
+                priceData.AddPrintData("C", 12, m_InvData.TotalAmount.ToString("#,0")).ExcelCellSet(m_UsedExcel);
+
+                // ⑥ 消費税(14行目 C列)
+                ExcelPrintData taxData = new ExcelPrintData();
+                taxData.AddPrintData("C", 13, m_InvData.TaxAmount.ToString("#,0")).ExcelCellSet(m_UsedExcel);
+
+                // 工事名(16行目 D列)
+                //ExcelPrintData cnstnameData = new ExcelPrintData();
+                //cnstnameData.AddPrintData("D", 15, m_lstReqHead[0].ReqConstructionName).ExcelCellSet(m_UsedExcel);
+
+                // 会社名
+                string strCompany = string.Format("{0}　{1}", CommonMotions.SystemMasterData.CompanyName1
+                                                                , CommonMotions.SystemMasterData.CompanyName2);
+
+                // 代表者名
+                string strPresident = string.Format("{0} {1}", CommonMotions.SystemMasterData.CEOPositionName.Trim()
+                                                                , CommonMotions.SystemMasterData.CEOName.Trim());
+
+                // 郵便番号
+                string strZip = "〒" + CommonMotions.SystemMasterData.ZipCode;
+
+                // 住所
+                string strAddr = CommonMotions.SystemMasterData.Address1;
+                if (CommonMotions.SystemMasterData.Address2 != string.Empty)
+                {
+                    strAddr += CommonMotions.SystemMasterData.Address2;
+                }
+                if (CommonMotions.SystemMasterData.Address3 != string.Empty)
+                {
+                    strAddr += CommonMotions.SystemMasterData.Address3;
+                }
+
+                // TEL/FAX
+
+                string strTelFax = "";
+
+                if (CommonMotions.SystemMasterData.PhoneNumber != string.Empty)
+                {
+                    strTelFax = "TEL " + CommonMotions.SystemMasterData.PhoneNumber + "(代)";
+                }
+                if (CommonMotions.SystemMasterData.FaxNumber != string.Empty)
+                {
+                    if (strTelFax.Length > 0)
+                    {
+                        strTelFax += " ";
+                    }
+                    strTelFax += "FAX " + CommonMotions.SystemMasterData.FaxNumber;
+                }
+                // URL
+                string strUrl = CommonMotions.SystemMasterData.HomePageURL;
+
+                ExcelPrintData companyData = new ExcelPrintData();
+                companyData.AddPrintData("L", 17, strCompany);                              // 会社名(18行目 L列)           
+                companyData.AddPrintData("L", 18, strPresident);                            // 代表者名(19行目 L列)           
+                companyData.AddPrintData("L", 19, strZip);                                  // 郵便番号(20行目 L列) 
+                companyData.AddPrintData("L", 20, strAddr);                                 // 住所(21行目 L列)           
+                companyData.AddPrintData("L", 21, strTelFax);                               // TEL/FAX(22行目 L列)           
+                companyData.AddPrintData("L", 22, strUrl);                                  // URL(23行目 L列)           
+                companyData.ExcelCellSet(m_UsedExcel);
+
+                ExcelPrintData commentData = new ExcelPrintData();
+                commentData.AddPrintData("C", 17, m_InvData.Comment1);                              // コメント1(18行目 C列)           
+                commentData.AddPrintData("C", 18, m_InvData.Comment2);                              // コメント2(19行目 C列)           
+                commentData.AddPrintData("C", 19, m_InvData.Comment3);                              // コメント3(20行目 C列)           
+                commentData.AddPrintData("C", 20, m_InvData.Comment4);                              // コメント4(21行目 C列)           
+                commentData.AddPrintData("C", 21, m_InvData.Comment5);                              // コメント5(22行目 C列)           
+                commentData.ExcelCellSet(m_UsedExcel);
+
+                m_dicConstructionBaseInfo.TryGetValue(m_lstReqHead[0].ReqConstructionCode, out ConstructionBaseInfo Info);
+
+                // 印鑑描画
+                PrintCoverSeal(Info.ConstructionPersonCode);
+
+                return CommonDefine.RetunAnswer.Answer0;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return CommonDefine.RetunAnswer.Answer1;
+            }
+        }
+        #endregion
+
+        #region 請求書(一覧)作成
+        /// <summary>
+        /// 請求書(一覧)作成
+        /// </summary>
+        /// <returns></returns>
+        private CommonDefine.RetunAnswer PrintList()
+        {
+            try
+            {
+                int trow = 4;
+                ExcelPrintData ExcelPrnData = null;
+
+                //// 請求書表紙シートの取得
+                m_UsedExcel.ExcelSheetGet(s_DicSheetName[enumSheetName.List]);
+
+                List<int> lstKey = new List<int>(m_dicReqData.Keys);
+
+                foreach (int nReqNo in lstKey)
+                {
+                    List<RequestData> lstData = null;
+
+                    if (m_dicReqData.TryGetValue(nReqNo, out lstData) == false)
+                    {
+                        continue;
+                    }
+
+                    foreach (RequestData ReqData in lstData)
+                    {
+                        // 工事情報取得
+                        if (!m_dicConstructionBaseInfo.TryGetValue(ReqData.MainConstructionCode, out ConstructionBaseInfo Info)) continue;
+
+                        int nOrderNo = 0;
+                        foreach (RequestHead wrk in m_lstReqHead)
+                        {
+                            // 同じ請求番号を探す
+                            if (wrk.RequestNo != ReqData.RequestNo) continue;
+                            nOrderNo = wrk.OrderNo;
+                            break;
+                        }
+
+                        StringBuilder strname = new StringBuilder();
+                        strname.AppendFormat("{0}-{1}\r\n", (ReqData.MainConstructionCode / 100), (ReqData.MainConstructionCode % 100).ToString("00"));
+                        strname.Append(ReqData.ConstructionName);
+                        // 分割は回数追加
+                        if (m_ExecuteSubFlg == (int)ConstructionBaseInfo.BillingSplitFlgDef.SplitBilling)
+                        {
+                            if (nOrderNo > 0) strname.AppendFormat("：請求{0}回目", nOrderNo);
+                        }
+
+                        ExcelPrnData = new ExcelPrintData();
+                        ExcelPrnData.AddPrintData("B", trow, strname.ToString());             // 工事件名
+                        ExcelPrnData.AddPrintData("C", trow, string.Format("{0}年{1}月{2}日"
+                                                                        , Info.ConstructionPeriodStart.Year
+                                                                        , Info.ConstructionPeriodStart.Month.ToString("00")
+                                                                        , Info.ConstructionPeriodStart.Day.ToString("00")));    // 工期開始
+
+                        string EndDate = string.Empty;
+                        string DateDescription = string.Empty;
+                        if (Info.RevCompleteDate != DateTime.MinValue)
+                        {   // 検査是正完了日
+                            EndDate = string.Format("{0}年{1}月{2}日"
+                                                                    , Info.RevCompleteDate.Year
+                                                                    , Info.RevCompleteDate.Month.ToString("00")
+                                                                    , Info.RevCompleteDate.Day.ToString("00"));
+                            DateDescription = "（現場是正完了日）";
+                        }
+                        else
+                        {   // 請求確認日
+                            EndDate = string.Format("{0}年{1}月{2}日"
+                                                                    , Info.BillingDate.Year
+                                                                    , Info.BillingDate.Month.ToString("00")
+                                                                    , Info.BillingDate.Day.ToString("00"));
+                            DateDescription = "（請求書確認日）";
+                        }
+                        ExcelPrnData.AddPrintData("C", trow + 1, string.Format("～ {0}", EndDate));                 // 工期終了
+                        ExcelPrnData.AddPrintData("C", trow + 2, DateDescription);                                  // 終了日説明
+
+                        long lAmount = ReqData.RequestAmount0;
+                        lAmount += ReqData.RequestAmount1;
+                        lAmount += ReqData.RequestAmount2;
+                        lAmount += ReqData.RequestAmount3;
+                        lAmount += ReqData.RequestAmount4;
+                        lAmount += ReqData.RequestAmount5;
+                        lAmount += ReqData.RequestAmount6;
+                        lAmount += ReqData.TaxAmount;
+                        lAmount += ReqData.UnpaidAmount;
+
+                        ExcelPrnData.AddPrintData("D", trow, lAmount.ToString("#,0"));                                  // 請求金額
+
+                        ExcelPrnData.AddPrintData("E", trow, ReqData.Note);                                             // 備考
+                        ExcelPrnData.ExcelCellSet(m_UsedExcel);
+
+                        trow += 3;
+
+                    }
+                }
+
+                return CommonDefine.RetunAnswer.Answer0;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return CommonDefine.RetunAnswer.Answer1;
+            }
+        }
+        #endregion
+
+        #region 請求書(内訳)作成
+        /// <summary>
+        /// 請求書(内訳)作成
+        /// </summary>
+        /// <param name="dicReqDetail"></param>
+        /// <param name="constLedger"></param>
+        /// <param name="lstConstLink"></param>
+        /// <returns></returns>
+        private CommonDefine.RetunAnswer PrintDetail(int no
+                                                    , RequestHead ReqHead
+                                                    , RequestData ReqData
+                                                    , ConstructionBaseInfo Info)
+        {
+            try
+            {
+                // 請求書内訳シートの取得
+                m_UsedExcel.ExcelSheetGet(s_DicSheetName[enumSheetName.Detail]);
+
+                ExcelPrintData ExcelPrnData = null;
+
+                // ------------------------------- 工事名 -------------------------------
+                // ① 工事件名
+                ExcelPrnData = new ExcelPrintData();
+                ExcelPrnData.AddPrintData("C", 2, ReqData.ConstructionName).ExcelCellSet(m_UsedExcel);
+
+                // ------------------------------- 請負金額 -------------------------------
+                ExcelPrnData = new ExcelPrintData();
+                ExcelPrnData.AddPrintData("A", 5, no.ToString());
+                ExcelPrnData.AddPrintData("G", 5, ReqData.ContractAmount.ToString("#,0"));
+                ExcelPrnData.ExcelCellSet(m_UsedExcel);
+
+                // ------------------------------- 前回ご請求分 -------------------------------
+                // 分割払いの場合
+                if (Info.BillingSplitFlg == (int)ConstructionBaseInfo.BillingSplitFlgDef.SplitBilling)
+                {
+                    ExcelPrnData = new ExcelPrintData();
+                    ExcelPrnData.AddPrintData("B", 7, "前回ご請求済分");
+                    ExcelPrnData.AddPrintData("C", 7, "前回請求書参照※増減補正済み");
+                    ExcelPrnData.AddPrintData("D", 7, "1");
+                    ExcelPrnData.AddPrintData("E", 7, "式");
+                    ExcelPrnData.AddPrintData("G", 7, ReqData.PaidAmount.ToString("#,0"));
+                    ExcelPrnData.ExcelCellSet(m_UsedExcel);
+                }
+
+                long lTotalAmount = 0;
+
+                // ------------------------------- 見積金額（本工事） -------------------------------
+                ExcelPrnData = new ExcelPrintData();
+                ExcelPrnData.AddPrintData("G", 9, ReqData.RequestAmount0.ToString("#,0"));
+                ExcelPrnData.ExcelCellSet(m_UsedExcel);
+
+                lTotalAmount += ReqData.RequestAmount0;
+
+                // ------------------------------- 見積金額（増減工事） -------------------------------
+                long[] lAmount = new long[] { ReqData.RequestAmount1
+                                            , ReqData.RequestAmount2
+                                            , ReqData.RequestAmount3
+                                            , ReqData.RequestAmount4
+                                            , ReqData.RequestAmount5
+                                            , ReqData.RequestAmount6 };
+                string[] strTitle = new string[] { "増減工事１"
+                                                    , "増減工事２"
+                                                    , "増減工事３"
+                                                    , "増減工事４"
+                                                    , "増減工事５"
+                                                    , "増減工事６" };
+
+                for (int i = 0; i < 6; i++)
+                {
+                    if (lAmount[i] > 0)
+                    {
+                        ExcelPrnData = new ExcelPrintData();
+                        ExcelPrnData.AddPrintData("B", 10 + i, strTitle[i]);
+                        ExcelPrnData.AddPrintData("C", 10 + i, "追加増減見積もり参照");
+                        ExcelPrnData.AddPrintData("D", 10 + i, "1");
+                        ExcelPrnData.AddPrintData("E", 10 + i, "式");
+                        ExcelPrnData.AddPrintData("G", 10 + i, lAmount[i].ToString("#,0"));
+                        ExcelPrnData.ExcelCellSet(m_UsedExcel);
+
+                        lTotalAmount += lAmount[i];
+                    }
+                }
+
+                // ------------------------------- 今回ご請求分 -------------------------------
+                ExcelPrnData = new ExcelPrintData();
+                ExcelPrnData.AddPrintData("G", 17, lTotalAmount.ToString("#,0"));
+                ExcelPrnData.ExcelCellSet(m_UsedExcel);
+
+                // ------------------------------- 請負金額残金 -------------------------------
+                // 分割払いの場合
+                if (Info.BillingSplitFlg == (int)ConstructionBaseInfo.BillingSplitFlgDef.SplitBilling)
+                {
+                    ExcelPrnData = new ExcelPrintData();
+                    ExcelPrnData.AddPrintData("B", 19, "請負金額残金");
+                    ExcelPrnData.AddPrintData("D", 19, "1");
+                    ExcelPrnData.AddPrintData("E", 19, "式");
+                    ExcelPrnData.AddPrintData("G", 19, ReqData.UnclaimedAmount.ToString("#,0"));
+                    ExcelPrnData.ExcelCellSet(m_UsedExcel);
+                }
+
+                // ------------------------------- 未入金分 -------------------------------
+                if (ReqData.UnpaidAmount > 0)
+                {
+                    ExcelPrnData = new ExcelPrintData();
+                    ExcelPrnData.AddPrintData("B", 21, "未入金分");
+                    ExcelPrnData.AddPrintData("G", 21, ReqData.UnpaidAmount.ToString("#,0"));
+                    ExcelPrnData.ExcelCellSet(m_UsedExcel);
+
+                    lTotalAmount += ReqData.UnpaidAmount;
+                }
+
+                // ------------------------------- 小計 -------------------------------
+                ExcelPrnData = new ExcelPrintData();
+                ExcelPrnData.AddPrintData("G", 23, lTotalAmount.ToString("#,0"));
+                ExcelPrnData.ExcelCellSet(m_UsedExcel);
+
+                // ------------------------------- 消費税 -------------------------------
+                ExcelPrnData = new ExcelPrintData();
+                ExcelPrnData.AddPrintData("C", 24, string.Format("{0}%", CommonMotions.SystemMasterData.ConsumptionTax));
+                ExcelPrnData.AddPrintData("G", 24, ReqData.TaxAmount.ToString("#,0"));
+                ExcelPrnData.ExcelCellSet(m_UsedExcel);
+                lTotalAmount += ReqData.TaxAmount;
+
+                // ------------------------------- 税込金額合計 -------------------------------
+                ExcelPrnData = new ExcelPrintData();
+                ExcelPrnData.AddPrintData("G", 25, lTotalAmount.ToString("#,0"));
+                ExcelPrnData.ExcelCellSet(m_UsedExcel);
+
+                return CommonDefine.RetunAnswer.Answer0;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return CommonDefine.RetunAnswer.Answer1;
+            }
+
+        }
+        #endregion
+
+        #region Excelデータ出力用内部クラス定義
+        /// <summary>
+        /// Excelデータ出力用内部クラス定義
+        /// </summary>
+        private class ExcelPrintData
+        {
+            // Excelデータ保持用用ディクショナリ
+            private Dictionary<int, Dictionary<int, object>> m_DicPrintData = new Dictionary<int, Dictionary<int, object>>();
+
+            // Excelカラム名取得用
+            private static char[] s_Asc = { 'A', 'B', 'C', 'D', 'E'
+                                            , 'F', 'G', 'H', 'I', 'J'
+                                            , 'K', 'L', 'M', 'N', 'O'
+                                            , 'P', 'Q', 'R', 'S', 'T'
+                                            , 'U', 'V', 'W', 'X', 'Y'
+                                            , 'Z' };
+
+            private int m_RowMin = int.MaxValue;
+            private int m_RowMax = int.MinValue;
+            private int m_ColMin = int.MaxValue;
+            private int m_ColMax = int.MinValue;
+
+            /// <summary>
+            /// エクセルカラム名とインデックス番号のディクショナリ
+            /// </summary>
+            private static Dictionary<string, int> s_IndexOfExcelColumn = InitDicColumnIndex();
+
+            #region Excelカラムインデックスディクショナリ作成メソッド
+            /// <summary>
+            /// Excelカラムインデックスディクショナリ作成メソッド
+            /// </summary>
+            /// <returns></returns>
+            private static Dictionary<string, int> InitDicColumnIndex()
+            {
+                var result = new Dictionary<string, int>();
+
+                for (int indx = 0; indx < 256; indx++)
+                {
+                    string res = GetColumnString(indx);
+
+                    result.Add(res, indx);
+
+                }
+                return result;
+            }
+            #endregion
+
+            #region カラム英字名を取得
+            /// <summary>
+            /// カラム英字名を取得
+            /// </summary>
+            /// <param name="colIndex"></param>
+            /// <returns></returns>
+            private static string GetColumnString(int colIndex)
+            {
+                string res = "";
+
+                int court = colIndex;
+                while (court >= s_Asc.Count())
+                {
+                    res = s_Asc[court % s_Asc.Count()] + res;
+                    court = (int)Math.Truncate((double)court / (double)s_Asc.Count() - 1);
+                }
+                res = s_Asc[court % s_Asc.Count()] + res;
+
+                return res;
+            }
+            #endregion
+
+            #region データ追加
+            /// <summary>
+            /// データ追加
+            /// </summary>
+            /// <param name="colName">カラム名文字(※ "A", "B", 等...</param>
+            /// <param name="rowNo">行インデックス番号 0オリジン</param>
+            /// <param name="data">出力データオブジェクト</param>
+            /// <returns></returns>
+            public ExcelPrintData AddPrintData(string colName, int rowNo, object data)
+            {
+                return AddPrintData(s_IndexOfExcelColumn[colName], rowNo, data);
+            }
+            #endregion
+
+            #region データ追加
+            /// <summary>
+            /// データ追加
+            /// </summary>
+            /// <param name="colIndex">カラムインデックス 0オリジン</param>
+            /// <param name="rowNo">行インデックス番号 0オリジン</param>
+            /// <param name="data">出力データオブジェクト</param>
+            /// <returns></returns>
+            public ExcelPrintData AddPrintData(int colIndex, int rowNo, object data)
+            {
+                if (!m_DicPrintData.ContainsKey(rowNo))
+                    m_DicPrintData[rowNo] = new Dictionary<int, object>();
+
+                m_DicPrintData[rowNo][colIndex] = data;
+
+                if (m_RowMin > rowNo) m_RowMin = rowNo;
+                if (m_RowMax < rowNo) m_RowMax = rowNo;
+                if (m_ColMin > colIndex) m_ColMin = colIndex;
+                if (m_ColMax < colIndex) m_ColMax = colIndex;
+
+                return this;
+            }
+            #endregion
+
+            #region UsedExcelオブジェクトにデータをセットする
+            /// <summary>
+            /// UsedExcelオブジェクトにデータをセットする
+            /// </summary>
+            /// <param name="usedExcel">UsedExcelオブジェクト(シート取得済みであること)</param>
+            public void ExcelCellSet(UsedExcel usedExcel)
+            {
+                if (m_RowMin == int.MaxValue ||
+                    m_RowMax == int.MinValue ||
+                    m_ColMin == int.MaxValue ||
+                    m_ColMax == int.MinValue)
+                {
+                    return;
+                }
+
+                // オブジェクト配列を宣言
+                object[,] objCells = new object[m_RowMax - m_RowMin + 1, m_ColMax - m_ColMin + 1];
+
+                // 配列にデータを移し替える
+                foreach (int row in m_DicPrintData.Keys)
+                {
+                    foreach (int col in m_DicPrintData[row].Keys)
+                    {
+                        objCells[row - m_RowMin, col - m_ColMin] = m_DicPrintData[row][col];
+                    }
+                }
+
+                // セル名を取得
+                string startCell = GetColumnString(m_ColMin) + string.Format("{0}", m_RowMin + 1);
+                string endCell = GetColumnString(m_ColMax) + string.Format("{0}", m_RowMax + 1);
+
+                // セルにセット
+                usedExcel.ExcelCellSet(startCell, objCells, endCell);
+
+            }
+            #endregion
+        }
+        #endregion
+    }
+}
